package com.unis.hlht.server.common.mybatis;

import org.mybatis.spring.boot.autoconfigure.ConfigurationCustomizer;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

/**
 * @description:mybatis配置
 * @author:马伟栋
 * @version:v1.0
 * @create:2019/01/04-16:38
 **/
@Configuration
@SuppressWarnings("all")
public class MybatisConfig {
    @Bean
    public ConfigurationCustomizer configurationCustomizer() {
        return new ConfigurationCustomizer() {
            @Override
            public void customize(org.apache.ibatis.session.Configuration configuration) {
                //entity驼峰命名与table中下划线间隔字段名匹配
                configuration.setMapUnderscoreToCamelCase(true);
            }
        };
    }
}
