package com.unis.hlht.server.controller;

import com.unis.hlht.server.server.tabledata.TableDataServer;
import com.unis.hlht.server.utils.FileUtil;
import com.unis.hlht.server.utils.ResponseCode;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.Reader;
import java.sql.Clob;
import java.sql.SQLException;
import java.util.List;
import java.util.Map;


@Slf4j
@RestController
@RequestMapping("/test")
@SuppressWarnings("all")
public class TestController {

    @Autowired
    private TableDataServer tableDataServer;

    @Value("${baseFilePath}")
    private String baseFilePath;

    @PostMapping("/transWjl")
    public ResponseCode transWjl(Integer pageNo, Integer pageSize) {
        try {
            List<Map> odsUpDwxxjk = tableDataServer.findAllByLoadDate("ODS_UP_WJXXJK", null, null, null, pageSize, pageNo,null);
            for (Map map : odsUpDwxxjk) {
                String s = this.ClobToString((Clob) map.get("wjl"));
                FileUtil.toHexString(
                        FileUtil.toByteArray(baseFilePath + File.separator + s));
            }
            return ResponseCode.success();
        } catch (Exception e) {
            log.error("执行指令错误", e);
            return ResponseCode.error();
        }
    }

    // Clob类型 转String
    public String ClobToString(Clob clob) throws SQLException, IOException {
        String res= "";
        Reader is = clob.getCharacterStream();
        BufferedReader br = new BufferedReader(is);
        String s = br.readLine();
        StringBuffer sb = new StringBuffer();
        while (s != null) {
            sb.append(s);
            s = br.readLine();
        }
        res= sb.toString();
        if(br!=null){
            br.close();
        }
        if(is!=null){
            is.close();
        }
        return res;
    }



}
