package com.unis.hlht.server.controller.datashare;

import com.unis.hlht.server.server.datashare.DataShareServer;
import com.unis.hlht.server.utils.ResponseCode;
import io.swagger.annotations.Api;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.websocket.server.PathParam;

/**
 * @description:省级平台向国家平台数据请求共享数据接口
 * @author:马伟栋
 * @version:v1.0
 * @create:2019/02/19-14:05
 **/
@Slf4j
@RestController
@RequestMapping("/dataShare")
@Api(tags = "数据共享")
@SuppressWarnings("all")
public class DataShareController {

    @Autowired
    private DataShareServer server;

    @PostMapping("/req/{api}")
    public ResponseCode receiveInstruction(@PathVariable("api") String api) {
        try {
            server.dataShare(api);
            return  ResponseCode.success();
        } catch (Exception e) {
            log.error("数据共享接收数据失败！", e);
            return ResponseCode.error();
        }
    }

}
