package com.unis.hlht.server.controller.lylttj;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.github.pagehelper.PageInfo;
import com.unis.hlht.server.common.ResponseWrapper;
import com.unis.hlht.server.dto.lylttj.GmRuturnDTO;
import com.unis.hlht.server.server.lylttj.ReserveScaleServer;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;

/**
 * @description:粮油流通统计-地方储备规模库存年报数据接口
 * @author:马伟栋
 * @version:v1.0
 * @create:2019/02/19-14:05
 **/
@Slf4j
@RestController
@RequestMapping("/reserveScale")
@SuppressWarnings("all")
@Api(tags = "粮油流通统计-地方储备规模库存年报数据")
public class ReserveScaleController {

	@Autowired
	private ReserveScaleServer server;

	@PostMapping("/findAll/{page}/{pageSize}")
	@ApiOperation(value = "列表获取")
	public ResponseWrapper findAll(@RequestBody(required = false) GmRuturnDTO dto,
			@PathVariable("page") Integer page, @PathVariable("pageSize") Integer pageSize) {
		try {
			// 上传数据明细
			PageInfo collect = server.findAll(dto, page, pageSize);
			// 数据返回
			return ResponseWrapper.success(collect);
		} catch (Exception e) {
//			log.error("数据上传记录获取失败", e);
			e.printStackTrace();
			return ResponseWrapper.error("数据上传记录获取失败");
		}
	}

}
