package com.unis.hlht.server.controller.uploadmemo;

import com.unis.hlht.server.common.ResponseWrapper;
import com.unis.hlht.server.dto.uploadmemo.RequestParamsDTO;
import com.unis.hlht.server.server.uploadmemo.DataUploadMemoServer;
import io.swagger.annotations.Api;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @description:数据上传记录控制类
 * @author:马伟栋
 * @version:v1.0
 * @create:2019/02/19-14:05
 **/
@Slf4j
@RestController
@RequestMapping("/uploadMemo")
@Api(tags = "数据上传记录")
@SuppressWarnings("all")
public class DataUploadMemoController {

    @Autowired
    private DataUploadMemoServer server;

    @PostMapping("/findCollect")
    public ResponseWrapper findCollect(@RequestBody(required = false) RequestParamsDTO dto) {
        try {
            //上传数据明细
            List<Map> collect = server.findCollect(dto);
            //上传数据总量
            Integer totalUploadSize = server.findUploadDataCount(dto);
            HashMap<Object, Object> map = new HashMap<>();
            map.put("totalUploadSize", totalUploadSize);
            collect.add(map);
            //数据返回
            return ResponseWrapper.success(collect);
        } catch (Exception e) {
            log.error("数据上传记录获取失败", e);
            return ResponseWrapper.error("数据上传记录获取失败");
        }
    }

}
