package com.unis.hlht.server.dto.instruction;

import lombok.Data;

/**
 * @description:数据上传传输对象
 * @author:马伟栋
 * @version:v1.0
 * @create:2019/02/19-17:46
 **/
@Data
@SuppressWarnings("all")
public class UpLoadDTO {

    /**
     * 报文标识ID:不可空；
     */
    private String id;

    /**
     * 身份ID：不可空；
     */
    private String uid;

    /**
     * 指令ID：需要和国家平台下发的数据指令一致；不可空；
     */
    private String orderid;

    /**
     * 身份签名：RSA的私钥对行政区划代码和当天日期对进行签名；
     * 格式：610000_2018-06-02
     * 不可空
     */
    private String access_token;

    /**
     * 数据总条数：数据总条数是指令要求上传的数据的此接口的数据总条数，不是本次上传的数据条数；
     * 可空
     */
    private Integer datalength;

    /**
     * 数据主体：单次上传数据量最大为100条；需要通过国家平台的公钥进行数据加密；
     * 不可空
     */
    private String data;

    /**
     * 数据摘要:data的MD5码
     * 不可空
     */
    private String digst;

}
