package com.unis.hlht.server.factory;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.unis.hlht.server.po.table.TableInfoPO;

import java.util.List;
import java.util.Map;

/**
 * @description:sql工厂
 * @author:马伟栋
 * @version:v1.0
 * @create:2019/02/25-17:57
 **/
@SuppressWarnings("all")
public class ActivationProvider {

    /**
     * 省平台向国家平台请求的共享数据持久化插入sql
     *
     * @param map
     * @return
     * @throws Exception
     */
    public String insertShareDataSql(Map map) throws Exception {
        String data = (String) map.get("data");
        String tableName = (String) map.get("tableName");
        List<TableInfoPO> tableInfoPOS = JSONArray.parseArray(JSON.toJSONString(map.get("columnNames")), TableInfoPO.class);
        List<Map> shareData = JSONArray.parseArray(data, Map.class);
        //sql前部分
        StringBuffer sqlfront = new StringBuffer();
        //sql后部分
        StringBuffer sqlLatter = new StringBuffer();
        //字段拼接
        String colStr = columnSplice(tableInfoPOS);
        sqlfront.append("insert all into ");
        sqlfront.append(tableName);
        sqlfront.append(colStr);
        sqlLatter.append(" values ");
        int count1 = 0;
        for (Map mapData : shareData) {
            sqlLatter.append(" (");
            //插入sql VALUES 部分拼接
            int count2 = 0;
            for (TableInfoPO tableInfoPO : tableInfoPOS) {
                Object columnV = mapData.get(tableInfoPO.getColumnName());
                String dataType = tableInfoPO.getDataType();
                if (columnV == null) {
                    sqlLatter.append("null");
                } else if ("NUMBER".equalsIgnoreCase(dataType)) {
                    sqlLatter.append(columnV);
                } else if ("DATE".equalsIgnoreCase(dataType)) {
                    sqlLatter.append("to_date ( '" + columnV + "' , 'YYYY-MM-DD HH24:MI:SS')");
                } else {
                    sqlLatter.append("'");
                    sqlLatter.append(columnV);
                    sqlLatter.append("'");
                }
                if (count2 < tableInfoPOS.size() - 1) {
                    sqlLatter.append(",");
                }
                count2++;
            }
            sqlLatter.append(") ");
            if (count1 < shareData.size() - 1) {
                sqlLatter.append(" into ");
                sqlLatter.append(tableName);
                sqlLatter.append(colStr);
                sqlLatter.append(" values ");
            }
            count1++;
        }
        sqlLatter.append(" select 1 from dual");
        return sqlfront.append(sqlLatter).toString();
    }

    private String columnSplice(List<TableInfoPO> tableInfoPOS) {
        //字段部分
        StringBuffer colStr = new StringBuffer();
        if (tableInfoPOS != null && tableInfoPOS.size() > 0) {
            //sql字段部分拼接
            colStr.append(" (");
            int count3 = 0;
            for (TableInfoPO tableInfoPO : tableInfoPOS) {
                //字段名小写
//                colStr.append("\"");
//                colStr.append(iter.next().toLowerCase());
//                colStr.append("\"");
                //字段名大写
                colStr.append(tableInfoPO.getColumnName());
                if (count3 < tableInfoPOS.size() - 1) {
                    colStr.append(",");
                }
                count3++;
            }
            colStr.append(") ");
            return colStr.toString();
        }
        return "";
    }

}
