package com.unis.hlht.server.mapper.apimappingtable;

import com.unis.hlht.server.mapper.MyMapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.Update;

/**
 * @description:接口名与表名对应关系数据访问对象
 * @author:马伟栋
 * @version:v1.0
 * @create:2019/02/19-16:34
 **/
@SuppressWarnings("all")
public interface ApiMappingTableMapper extends MyMapper {

    @Select("select TABLE_NAME from API_MAPPING_TABLE where api = lower(#{api}) or api = upper(#{api})")
    String findTableNameByApi(@Param("api") String api);

    @Select("select memo from API_MAPPING_TABLE where api = lower(#{api}) or api = upper(#{api})")
    String findMemoByApi(@Param("api") String api);

    @Update("update API_MAPPING_TABLE set pointer = #{nextPointer} where api = lower(#{api}) or api = upper(#{api})")
    void updatePointer(@Param("api") String api, @Param("nextPointer") String nextPointer);

    @Select("select pointer from API_MAPPING_TABLE where api = lower(#{api}) or api = upper(#{api})")
    String findPointerByApi(@Param("api") String api);

    @Select("select API from API_MAPPING_TABLE where TABLE_NAME = lower(#{tableName}) or TABLE_NAME = upper(#{tableName})")
    String findApiByTableName(@Param("tableName") String tableName);

}
