package com.unis.hlht.server.mapper.uploadmemo;

import com.unis.hlht.server.dto.uploadmemo.RequestParamsDTO;
import com.unis.hlht.server.mapper.MyMapper;
import com.unis.hlht.server.po.table.DataUploadMemoPO;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Select;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
 * @description:
 * @author:马伟栋
 * @version:v1.0
 * @create:2019/07/09-11:22
 **/
@SuppressWarnings("all")
@Repository
public interface DataUploadMemoMapper extends MyMapper<DataUploadMemoPO> {

    @Select({"<script> SELECT api,MAX(api_name) api_name,SUM(current_upload_size) upload_size,MAX(upload_result) upload_result FROM UPLOAD_MEMO  where  upload_result_code = '200'",
            "<if test = 'startTime != null and startTime != \"\"'>",
            "and upload_time &gt;= to_date(#{startTime},'yyyy-MM-dd HH24:MI:SS')",
            "</if>",
            "<if test = 'endTime != null and endTime != \"\"'>",
            "and upload_time &lt;= to_date(#{endTime},'yyyy-MM-dd HH24:MI:SS')",
            "</if>",
            "<if test = 'api != null and api != \"\"'>",
            "and api = #{api}",
            "</if>",
            " GROUP BY API ORDER BY API ASC",
            "</script>"})
    List<Map> findCollect(RequestParamsDTO params);

    @Select({"<script> SELECT SUM(SUM(current_upload_size)) total_upload_szie  FROM UPLOAD_MEMO  where  upload_result_code = '200'",
            "<if test = 'startTime != null and startTime != \"\"'>",
            "and upload_time &gt;= to_date(#{startTime},'yyyy-MM-dd HH24:MI:SS')",
            "</if>",
            "<if test = 'endTime != null and endTime != \"\"'>",
            "and upload_time &lt;= to_date(#{endTime},'yyyy-MM-dd HH24:MI:SS')",
            "</if>",
            "<if test = 'api != null and api != \"\"'>",
            "and api = #{api}",
            "</if>",
            " GROUP BY API ORDER BY API ASC",
            "</script>"})
    Integer findUploadDataCount(RequestParamsDTO params);

    @Insert("insert into UPLOAD_MEMO (ID,API,API_NAME,TOTAL_UPLOAD_SIZE,UPLOAD_COUNT,CURRENT_UPLOAD_SIZE,UPLOAD_RESULT,UPLOAD_TIME,UPLOAD_RESULT_CODE) values (#{id},#{api},#{apiName},#{totalUploadSize},#{uploadCount},#{currentUploadSize},#{uploadResult},#{uploadTime},#{uploadResultCode})")
    void insertSelect(DataUploadMemoPO po);
}
