package com.unis.hlht.server.server.apimappingtable;

import com.unis.hlht.server.mapper.apimappingtable.ApiMappingTableMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @description:api和表名对应关系表服务对象
 * @author:马伟栋
 * @version:v1.0
 * @create:2019/02/25-16:27
 **/
@Service
@SuppressWarnings("all")
public class ApiMappingTableServer {

    @Autowired
    private ApiMappingTableMapper mappingTableMapper;

    /**
     * 根据api查询表名
     *
     * @param apiName
     * @return
     */
    public String findTableNameByApi(String apiName) {
        return mappingTableMapper.findTableNameByApi(apiName);
    }

    /**
     * 根据api查询接口中文名
     *
     * @param apiName
     * @return
     */
    public String findMemoByApi(String api) {
        return mappingTableMapper.findMemoByApi(api);
    }

    /**
     * 更新数据查询起始位置
     *
     * @param api
     * @param nextPointer
     */
    public void updatePointer(String api, String nextPointer) {
        mappingTableMapper.updatePointer(api, nextPointer);
    }

    /**
     * 根据api查询数据获取的起始位置
     *
     * @param api
     * @return
     */
    public String findPointerByApi(String api) {
        return mappingTableMapper.findPointerByApi(api);
    }

    /**
     * 根据表名获取api编码
     */
    public String findApiByTableName(String tableName) {
        return mappingTableMapper.findApiByTableName(tableName);
    }

}
