package com.unis.hlht.server.server.lylttj;

import java.util.ArrayList;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.unis.hlht.server.dto.lylttj.InfrastructureInvestmentDTO;
import com.unis.hlht.server.dto.lylttj.ProcessTransformDTO;
import com.unis.hlht.server.dto.lylttj.ReserveScaleDto;
import com.unis.hlht.server.mapper.lylttj.InfrastructureInvestmentMapper;

/**
 * @description:基础设施投资情况数据接口
 * @author:马伟栋
 * @version:v1.0
 * @create:2019/07/09-11:23
 **/
@Service
@SuppressWarnings("all")
public class InfrastructureInvestmentServer {

	@Autowired
	private InfrastructureInvestmentMapper mapper;

	public PageInfo findAll(InfrastructureInvestmentDTO dto, int page, int pageSize) {
		PageHelper.startPage(page, pageSize);

		if (dto.getDatatime() != null && !("").equals(dto.getDatatime())) {
			dto.setDatatime(dto.getDatatime().substring(0, 4));
		}
		List<InfrastructureInvestmentDTO> list = mapper.findAll(dto);
		for (InfrastructureInvestmentDTO pro : list) {
			StringBuffer sb = new StringBuffer();
			List<InfrastructureInvestmentDTO> detailList = mapper.findDetail(pro);
			for (InfrastructureInvestmentDTO detailPro : detailList) {
				sb.append(detailPro.getLsltjcssjstzqk());
				sb.append("(");
				sb.append(detailPro.getSl());
				sb.append(")");
				sb.append("、");
			}
			pro.setLsltjcssjstzqk(sb.length() == 0 ? "" : sb.toString().substring(0, sb.toString().lastIndexOf("、")));
		}
		PageInfo pageInfo = new PageInfo(list);
		return pageInfo;
	}

}
