package com.unis.hlht.server.server.lylttj;

import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.Map.Entry;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.unis.hlht.server.dto.lylttj.GmRuturnDTO;
import com.unis.hlht.server.dto.lylttj.GmkcDTO;
import com.unis.hlht.server.dto.lylttj.ReserveScaleDto;
import com.unis.hlht.server.dto.lylttj.ReturnDTO;
import com.unis.hlht.server.dto.uploadmemo.RequestParamsDTO;
import com.unis.hlht.server.mapper.lylttj.ReserveScaleMapper;

/**
 * @description:地方储备规模库存年报数据接口
 * @author:马伟栋
 * @version:v1.0
 * @create:2019/07/09-11:23
 **/
@Service
@SuppressWarnings("all")
public class ReserveScaleServer {

	@Autowired
	private ReserveScaleMapper reserveScaleMapper;

	public PageInfo findAll(GmRuturnDTO dto, int page, int pageSize) {
		PageHelper.startPage(page, pageSize);
		List<ReserveScaleDto> list = reserveScaleMapper.findAll(dto);
		List<ReturnDTO> returnDTOs = new ArrayList();
		for (ReserveScaleDto res : list) {
			ReserveScaleDto param = new ReserveScaleDto();
			param.setUnitid(res.getUnitid());
			param.setDatatime(res.getDatatime());
			//根据库点名称和年度查询规模库存
			List<ReserveScaleDto> dataList = reserveScaleMapper.findDetail(param);
			ReturnDTO returnDTO = new ReturnDTO();
			Map<String,Double> pzCount = new HashMap<>();
			Map<String,Double> gmkcCount = new HashMap<>();
			returnDTO.setGmkcCount(gmkcCount);
			returnDTO.setDwmc(dataList.get(0).getDwmc());
			returnDTO.setDatatime(dataList.get(0).getDatatime());
			returnDTO.setPzCount(pzCount);
			for (ReserveScaleDto data : dataList) {
				if (gmkcCount.containsKey(data.getGmkc())) {
					Double gmkc = gmkcCount.get(data.getGmkc()) + data.getBbje1();
					gmkcCount.put(data.getGmkc(), gmkc);
					//品种(n吨)
					if(data.getBbje1() == null) {data.setBbje1(0D);}
					if (pzCount.containsKey(data.getPzzb())) {
						if(gmkcCount.get(data.getGmkc()) == null) {gmkcCount.put(data.getGmkc(),0D);}
						Double pzcountAf = pzCount.get(data.getPzzb()) + data.getBbje1();
						pzCount.put(data.getPzzb(), pzcountAf);
					} else {
						pzCount.put(data.getPzzb(), data.getBbje1());
					}
				} else {
					gmkcCount.put(data.getGmkc(), data.getBbje1());
					//品种(n吨)
					if (pzCount.containsKey(data.getPzzb())) {
						if(pzCount.get(data.getPzzb()) == null) {pzCount.put(data.getPzzb(),0D);}
						Double pzcountAf = pzCount.get(data.getPzzb()) + data.getBbje1();
						pzCount.put(data.getPzzb(), pzcountAf);
					} else {
						pzCount.put(data.getPzzb(), data.getBbje1());
					}
				}
			}
			
			returnDTOs.add(returnDTO);
		}
		List<GmRuturnDTO> GmRuturnDTOs = new ArrayList();
		for (ReturnDTO returndto : returnDTOs) {
			GmRuturnDTO gmRuturnDTO = new GmRuturnDTO();
			gmRuturnDTO.setDwmc(returndto.getDwmc());
			gmRuturnDTO.setDatatime(returndto.getDatatime().substring(0, 4));
			
			Map<String, Double> gmkc = returndto.getGmkcCount();
			Set<Entry<String, Double>> gmSet = gmkc.entrySet();
			StringBuffer gmkcSb = new StringBuffer();
			for (Entry<String, Double> entry : gmSet) {
				String key = entry.getKey();
				Double value = entry.getValue();
				gmkcSb.append(key).append("(").append(value).append(")");
				gmkcSb.append("、");				
			}
			
			Map<String, Double> pz = returndto.getPzCount();
			Set<Entry<String, Double>> pzSet = pz.entrySet();
			StringBuffer pzSb = new StringBuffer();
			for (Entry<String, Double> entry : pzSet) {
				String key = entry.getKey();
				Double value = entry.getValue();
				pzSb.append(key).append("(").append(value).append(")");
				pzSb.append("、");				
			}
			gmRuturnDTO.setGmkc(gmkcSb.toString().substring(0, gmkcSb.toString().lastIndexOf("、")));
			gmRuturnDTO.setPz(pzSb.toString().substring(0, pzSb.toString().lastIndexOf("、")));
			GmRuturnDTOs.add(gmRuturnDTO);
		}
		PageInfo pageInfo = new PageInfo(GmRuturnDTOs);
		return pageInfo;
	}

//	private void handleKclsxzSb(StringBuffer kclsxzSb, ReserveScaleDto res, List<ReserveScaleDto> dataList) {
//		JSONArray xzArr = new JSONArray();
//		JSONObject xzJsonObj = new JSONObject();
//		for (ReserveScaleDto data : dataList) {
//			//同一单位
//			if(data.getUnitid().equals(res.getUnitid()) && data.getDatatime().equals(res.getDatatime())) {
//				if(xzJsonObj.getJSONObject(data.))
//			}
//		}
//	}
	
}
