package com.unis.hlht.server.server.uploadmemo;

import com.unis.hlht.server.dto.uploadmemo.RequestParamsDTO;
import com.unis.hlht.server.mapper.uploadmemo.DataUploadMemoMapper;
import com.unis.hlht.server.po.table.DataUploadMemoPO;
import com.unis.hlht.server.utils.DateUtil;
import com.unis.hlht.server.utils.OrderID;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.Map;

/**
 * @description:数据上传记录服务类
 * @author:马伟栋
 * @version:v1.0
 * @create:2019/07/09-11:23
 **/
@Service
@SuppressWarnings("all")
public class DataUploadMemoServer {

    @Autowired
    private DataUploadMemoMapper mapper;

    /**
     * 保存
     *
     * @param po
     */
    @Transactional
    public void save(DataUploadMemoPO po) {
        po.setId(OrderID.getId());
        po.setUploadTime(DateUtil.getNowDate());
        // System.out.println("----" + po);
        mapper.insertSelect(po);
    }

    /**
     * 查询上传记录信息
     *
     * @param api
     * @param startTime
     * @param endTime
     */
    public List<Map> findCollect(RequestParamsDTO dto) {

        return mapper.findCollect(dto);

    }

    /**
     * 查询上传数据总量
     *
     * @param api
     * @param startTime
     * @param endTime
     */
    public Integer findUploadDataCount(RequestParamsDTO dto) {

        return mapper.findUploadDataCount(dto);

    }

}
