package com.unis.hlht.server.utils;

import com.github.pagehelper.PageInfo;
import lombok.extern.slf4j.Slf4j;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 功能描述: 将分页查询返回的page对象，转换为map
 *
 * @Auther: 蒋青茂
 * @Date: 2018/5/23 13:39
 */
@Slf4j
public class PageUtils {

    public static Map<String, Object> transToMap(PageInfo page) {
        Map<String, Object> map = new HashMap<String, Object>();
        //数据
        List<Object> list = page.getList();
        //是否是第一页
        boolean isFirst = page.isIsFirstPage();
        //是否是最后一页
        boolean isLast = page.isIsLastPage();
        //总页数
        int totalPages = page.getPages();
        //总数据条数
        long totalElements = page.getTotal();
        //当前页数
        int number = page.getPageNum();
        //每页多少条数据
        int size = page.getPageSize();

        map.put("list", list);
        map.put("isFirst", isFirst);
        map.put("isLast", isLast);
        map.put("totalPages", totalPages);
        map.put("totalElements", totalElements);
        map.put("number", number);
        map.put("size", size);

        return map;
    }

}
